/******************************************************************************

    $Id: expr.h,v 1.1 2003/08/28 17:43:44 mmp Exp $
    $Source: /archive/cvs/cc/src/cc/cpp/expr.h,v $

    This module contains the public interface to the library.
    
******************************************************************************/


// Expression types, EXPR.type
enum {
    E_VALUE,
    E_CONDITIONAL,
    E_LOGIC_OR,
    E_LOGIC_AND,
    E_BIT_OR,
    E_BIT_XOR,
    E_BIT_AND,
    E_EQ,
    E_NE,
    E_GT,
    E_LT,
    E_GE,
    E_LE,
    E_SHL,
    E_SHR,
    E_ADD,
    E_SUB,
    E_MUL,
    E_DIV,
    E_MOD,
    E_UPLUS,
    E_UMINUS,
    E_NOT,
    E_NEG
};

// Value in expression evaluation
struct tagVALUE {
    bool    is_signed;
    union {
        long            svalue;
        unsigned long   uvalue;
    } u;
};

// Expression in '#if' or '#elif' directive
struct tagEXPR {
    int type;
    union {
        VALUE value;
        struct {
            EXPR*       operand;        
        } unary;
        struct {
            EXPR*       left;
            EXPR*       right;
        } binary;
        struct {
            EXPR*       condition;
            EXPR*       iftrue;
            EXPR*       iffalse;
        } conditional;
    } u;
};
