/******************************************************************************

    $Id: output.c,v 1.5 2003/08/28 21:59:29 mmp Exp $
    $Source: /archive/cvs/cc/src/cc/cpp/output.c,v $

******************************************************************************/

#include "priv.h"

// Output list states
enum {
    OUTPUT_RESET,
    OUTPUT_PRAGMA,              // Seen '_Pragma'
    OUTPUT_PRAGMA_POPEN,        // Seen '_Pragma' '('
    OUTPUT_PRAGMA_STRLIT,       // Seen '_Pragma' '(' "strlit"
    OUTPUT_STRLIT               // Seen string
};


void cpp_output_append(CPP* cpp, PPTOKEN* token)
{
    switch ( token->token.tag ) {
        case T_FINAL_IDENT:
            token->token.tag = T_IDENT;
            /* fall through **/
        case T_IDENT:
            if ( strcmp(token->token.str,"_Pragma") == 0 ) {
                cpp->output_state = OUTPUT_PRAGMA;
            } else {
                cpp->output_state = OUTPUT_RESET;
            }
            break;
        case T_END:
            cpp->output_state = OUTPUT_RESET;
            break;
        case T_PAREN_OPEN:
            if ( cpp->output_state == OUTPUT_PRAGMA ) {
                cpp->output_state = OUTPUT_PRAGMA_POPEN;
            } else {
                cpp->output_state = OUTPUT_RESET;
            }
            break;
        case T_STRLIT:
            if ( cpp->output_state == OUTPUT_PRAGMA_POPEN 
              || cpp->output_state == OUTPUT_PRAGMA_STRLIT )
            {
                cpp->output_state = OUTPUT_PRAGMA_STRLIT;
            } else {
                cpp->output_state = OUTPUT_STRLIT;
            }
            break;
        case T_ERROR:
        case T_PRAGMA:
        case T_SPACE:
            break;
        default:
            cpp->output_state = OUTPUT_RESET;
            break;
    }

    if ( cpp->output_queue.last && cpp->output_queue.last->token.tag == T_END ) {
        // Special handling to ensure T_END is last token in list
        PPTOKEN tmp = *cpp->output_queue.last;
        *cpp->output_queue.last = *token;
        *token = tmp;
        cpp->output_queue.last->next = token;
        token->next = NULL;
        return;
    }

    cpp_list_append(&cpp->output_queue, token);
}


void cpp_output_appendlist(CPP* cpp, PPTOKEN* tokens)
{
    cpp_list_appendlist(&cpp->output_queue, tokens);
}


PPTOKEN* cpp_output_get(CPP* cpp)
{
    return cpp_list_getfirst(&cpp->output_queue);
}
