/******************************************************************************

    $Id: path.c,v 1.2 2003/08/28 19:12:27 mmp Exp $
    $Source: /archive/cvs/cc/src/cc/cpp/path.c,v $

******************************************************************************/

#include "priv.h"

#ifdef _WIN32
    #include <io.h>
    #define DIRSEP          "\\/:"
    #define LISTSEP         ';'
    #define PATHCMP(a,b)    stricmp(a,b)
#endif

#ifdef unix
    #include <unistd.h>
    #define DIRSEP "/"
    #define LISTSEP         ':'
    #define PATHCMP(a,b)    strcmp(a,b)
#endif


int cpp_is_dirsep(char ch)
{
    return ch && strchr(DIRSEP,ch);
}


char cpp_dirsep(void)
{
    return *DIRSEP;
}


char cpp_listsep(void)
{
    return LISTSEP;
}


int cpp_pathcmp(const char* path1, const char* path2)
{
    return PATHCMP(path1, path2);
}


bool cpp_is_path_abs(const char* path)
{
#ifdef _WIN32
    if ( ISALPHA(path[0]) && path[1]==':' ) {
        return true;
    }
#endif

    return cpp_is_dirsep(*path);
}


const char* cpp_basename(const char* path)
{
    const char* a;
    const char* b;

    for ( a = DIRSEP ; *a ; a++ ) {
        if ( (b=strrchr(path,*a)) != NULL ) {
            path = b+1;
        }
    }

    return path;
}


bool cpp_exists(const char* path)
{
    return access(path,0) == 0;
}
