/******************************************************************************

    $Id: str.c,v 1.1 2003/08/28 05:46:47 mmp Exp $
    $Source: /archive/cvs/cc/src/cc/cpp/str.c,v $

******************************************************************************/

#include "priv.h"


size_t cpp_nlcount(const char* str)
{
    size_t n = 0;

    for ( str = strchr(str, '\n') ; str ; str = strchr(str+1, '\n') ) {
        ++n;
    }

    return n;
}


const char* cpp_skipspace(const char* str)
{
    while ( ISSPACE(*str) ) {
        ++str;
    }
    return str;
}


size_t cpp_hash(const char* str)
{
    return cpp_hashn(str, strlen(str));
}


size_t cpp_hashn(const char* str, size_t len)
{
    const size_t NBITS = sizeof(size_t)*CHAR_BIT;
    const size_t N75   = ((size_t)(NBITS*0.75));
    const size_t N12   = ((size_t)(NBITS*0.125));
    const size_t HB    = (~((size_t)(~0)>>N12));

    size_t  g;
    size_t  h = 0;

    while (len--) {
        h = (h<<N12)+(unsigned char)(*str++);
        if ((g=(h&HB))!=0) {
            h = (h^(g>>N75)) & ~HB;
        }
    }

    return h;
}
