/******************************************************************************

    $Id: strtag.c,v 1.4 2003/08/28 20:51:57 mmp Exp $
    $Source: /archive/cvs/cc/src/cc/cpp/strtag.c,v $

******************************************************************************/

#include "priv.h"

// Describe token
const char* cpp_strtag(int tag)
{
    switch (tag) {
        case T_END        : return "end of input";
        case T_SPACE      : return "space";
        case T_PRAGMA     : return "pragma";
        case T_ERROR      : return "error";
        case T_IDENT      : return "identifier";
        case T_NUMLIT     : return "number";
        case T_STRLIT     : return "string";
        case T_CHRLIT     : return "character";
        case T_NOT        : return "'!'";
        case T_NE         : return "'!='";
        case T_HASH_HASH  : return "'##'";
        case T_HASH       : return "'#'";
        case T_MOD        : return "'%'";
        case T_MOD_ASSIGN : return "'%='";
        case T_AND_AND    : return "'&&'";
        case T_AND        : return "'&'";
        case T_AND_ASSIGN : return "'&='";
        case T_PAREN_OPEN : return "'('";
        case T_PAREN_CLOSE: return "')'";
        case T_MUL        : return "'*'";
        case T_MUL_ASSIGN : return "'*='";
        case T_ADD        : return "'+'";
        case T_INC        : return "'++'";
        case T_ADD_ASSIGN : return "'+='";
        case T_COMMA      : return "','";
        case T_SUB        : return "'-'";
        case T_DEC        : return "'--'";
        case T_SUB_ASSIGN : return "'-='";
        case T_ARROW      : return "'->'";
        case T_DOT        : return "'.'";
        case T_ELLIPSIS   : return "'...'";
        case T_DIV        : return "'/'";
        case T_DIV_ASSIGN : return "'/='";
        case T_COLON      : return "':'";
        case T_SEMI       : return "';'";
        case T_LT         : return "'<'";
        case T_SHL        : return "'<<'";
        case T_SHL_ASSIGN : return "'<<='";
        case T_LE         : return "'<='";
        case T_ASSIGN     : return "'='";
        case T_EQ         : return "'=='";
        case T_GT         : return "'>'";
        case T_GE         : return "'>='";
        case T_SHR        : return "'>>'";
        case T_SHR_ASSIGN : return "'>>='";
        case T_QMARK      : return "'?'";
        case T_SHARP_OPEN : return "'['";
        case T_SHARP_CLOSE: return "']'";
        case T_XOR        : return "'^'";
        case T_XOR_ASSIGN : return "'^='";
        case T_CURLY_OPEN : return "'{'";
        case T_OR         : return "'|'";
        case T_OR_ASSIGN  : return "'|='";
        case T_OR_OR      : return "'||'";
        case T_CURLY_CLOSE: return "'}'";
        case T_NEG        : return "'~'";
        case T_BAD        : return "bad character";
        case T_BOL_HASH   : return "<BOL> '#'";
        case T_STRINGIZE  : return "stringize";
        case T_ARGUMENT   : return "argument";
        case T_PLACEMARKER: return "place marker";
        case T_FINAL_IDENT: return "final ident";
    }

    return "non-token";
}
